aboutsummaryrefslogtreecommitdiffstats
path: root/tools/vsperf-img-finalize.sh
diff options
context:
space:
mode:
authorJing Zhang <jing.c.zhang@nokia.com>2017-05-25 18:41:00 -0400
committerRoss Brattain <ross.b.brattain@intel.com>2017-08-15 00:59:22 +0000
commit39494c01b49cafd893982d74e030b9b96b5fa821 (patch)
treeb0358147876cd263385eb348d62021d2ccfc015b /tools/vsperf-img-finalize.sh
parent4f842b4a7cedcc5ba89542955bf2b64c3451361d (diff)
Integrate vsperf in Tgen mode
Problem: Running Vsperf in Tgen mode is supported but the integration is not complete at the code level i.e. not ready-to-use, and dpdk loopback is not supported inside the VM. Solution: (1) Completely automates VM image generation and supports 1G huge pages. (2) Adds a new test scenario VsperfDPDK for testpmd based loopback inside the VM. Update 1-2: Fixed "line too long" issues not reported by local run_tests.sh (why?) Update 3: Per comment change to use SSH.from_node() and add unit test cases Update 4: Add more unit test cases for coverage and ready the code for merge JIRA: YARDSTICK-661 Change-Id: Iea3014d4c83e1b0c079019a4ed27771d40a7eed8 Signed-off-by: Jing Zhang <jing.c.zhang@nokia.com>
Diffstat (limited to 'tools/vsperf-img-finalize.sh')
-rwxr-xr-xtools/vsperf-img-finalize.sh51
1 files changed, 51 insertions, 0 deletions
diff --git a/tools/vsperf-img-finalize.sh b/tools/vsperf-img-finalize.sh
new file mode 100755
index 000000000..cf3677b84
--- /dev/null
+++ b/tools/vsperf-img-finalize.sh
@@ -0,0 +1,51 @@
+#!/bin/bash
+##############################################################################
+# Copyright (c) 2017 Nokia
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
+
+# PREREQUISITES
+# modified image (yardstick-vsperf) must be uploaded to OpenStack
+# must have a proper flavor (vsperf-flavor) for the image e.g.
+# nova flavor-create vsperf-flavor auto 8192 80 6
+# nova flavor-key vsperf-flavor set hw:numa_nodes=1
+# nova flavor-key vsperf-flavor set hw:mem_page_size=1GB
+# nova flavor-key vsperf-flavor set hw:cpu_policy=dedicated
+# nova flavor-key vsperf-flavor set hw:vif_multiqueue_enabled=true
+
+stackname="vsperf-install-stack"
+template=vsperf_install.yml
+new_image_name="yardstick-vsperf-server"
+
+openstack stack create $stackname -f yaml -t $template
+progress="WARMING_UP"
+
+while [ "$progress" != "CREATE_COMPLETE" ]
+do
+ sleep 10
+ echo "check stack status......."
+ show_output=$(openstack stack show $stackname)
+ progress=$(echo $show_output | sed 's/^.*stack_status . \([^ ]*\).*$/\1/')
+ echo "$progress"
+ if [ "$progress" == "CREATE_FAILED" ];then
+ echo "create $stackname failed"
+ exit 1
+ fi
+done
+
+# has to stop the instance before taking the snapshot
+nova stop $stackname
+sleep 10
+
+status=$(nova image-create --poll $stackname $new_image_name)
+if [[ "$status" =~ "Finished" ]];then
+ echo "$new_image_name finished"
+fi
+
+nova delete $stackname
+sleep 10
+openstack stack delete --yes $stackname